Subject: Re: [PATCH 2/2] i2c: Add devtree-aware iic support for PPC4xx

From: David Gibson <[email-masked]>
Date: Wed, 17 Oct 2007 10:37:08 +1000

On Tue, Oct 16, 2007 at 09:19:39PM +0200, Jean Delvare wrote:
> On Mon, 15 Oct 2007 22:21:38 -0600, Grant Likely wrote:
> > On 10/15/07, David Gibson <[email-masked]> wrote:
> > > In fact I think it may be acceptle to do the idx++ thing in this
> > > situation.  Bus numbers are ugly, but it's not the worst ugliness in
> > > the horrible mess that is the Linux i2c subsystem.  It means that bus
> > > numbers are theoretically unstable, but that's increasingly true of
> > > devices of all sorts - it's up to udev to assign meaningful labels at
> > > the user level.
> 
> David, after such a rant against the Linux i2c subsystem, I sure hope
> that you're going to contribute patches to make it better (whatever you
> think needs to be improved, as you didn't say.)

I've frequently contemplated it.  In the unlikely event that it ever
bubbles to the top of my priorities, I might well.

> > I think the real problem here comes into play when there are 2 types
> > of i2c busses in the system.  If they both maintain their own idx++
> > values; then they will conflict.  If an auto assigned bus number is
> > used; then it needs to be assigned by the i2c infrastructure; not by
> > the driver.
> 
> Very true. If you aren't going to define the i2c bus numbers at
> platform data level, then you shouldn't be defining them _at all_.
> Don't use i2c_add_numbered_adapter, use i2c_add_adapter and let
> i2c-core choose an appropriate a bus number.

-- 
David Gibson			| I'll have my music baroque, and my code
david AT gibson.dropbear.id.au	| minimalist, thank you.  NOT _the_ _other_
				| _way_ _around_!
http://www.ozlabs.org/~dgibson